#!/bin/sh
#PBS -q h-regular
#PBS -l select=1
#PBS -W group_list=gk77
#PBS -l walltime=18:00:00
#PBS -N LISA-HI-UP-UPDOWN-LABELED-GOLD-NONENORM-LOGPROB-LINEAR-AGGREGATION-CWR-LOGSUMEXP_ADD
#PBS -j oe
#PBS -M christopher@orudo.cc
#PBS -m abe

export PATH=$PBS_O_PATH:$PATH

cd $PBS_O_WORKDIR
SAVEDIR=.model/lisa/injection/glove/labeled-relchain-aggregation-debug/conll05-lisa-none_norm-log_prob-up-updown-cwr-logsumexp_add
CONF=config/lisa/injection/glove/labeled-relchain-aggregation/conll05-lisa-u_ud-cwr.conf
SINGULARITY_IMG=/lustre/gk77/k77015/.Singularity/imgs/LISA.simg
ADDITIONAL_PARAMETERS="--hparam transformation_fn_norm=none,using_log_prob=True,use_hparams_aggregation_reduction_mode=True,aggregation_reduction_mode=logsumexp_add"

module add cuda9/9.0.176-cuDNN7.1.4 singularity/2.5.1
{
CUDA_VISIBLE_DEVICES=0 singularity exec --nv $SINGULARITY_IMG bin/train.sh $CONF --save_dir $SAVEDIR/run-1 --num_gpus 1 $ADDITIONAL_PARAMETERS &> $SAVEDIR/run-1/train.log
} &

{
sleep 600
CUDA_VISIBLE_DEVICES=1 singularity exec --nv $SINGULARITY_IMG bin/train.sh $CONF --save_dir $SAVEDIR/run-2 --num_gpus 1 $ADDITIONAL_PARAMETERS &> $SAVEDIR/run-2/train.log
} &
wait
